Index: issm/branches/trunk-jpl-damage/src/c/matlab/io/MatlabNArrayToNArray.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/matlab/io/MatlabNArrayToNArray.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/matlab/io/MatlabNArrayToNArray.cpp	(revision 12878)
@@ -15,5 +15,5 @@
 #include <mex.h>
 
-/*FUNCTION MatlabNArrayToNArray(double** pmatrix,int* pmatrix_numel,int* pmatrix_ndims,int** pmatrix_size,const mxArray* mxmatrix){{{1*/
+/*FUNCTION MatlabNArrayToNArray(double** pmatrix,int* pmatrix_numel,int* pmatrix_ndims,int** pmatrix_size,const mxArray* mxmatrix){{{*/
 int MatlabNArrayToNArray(double** pmatrix,int* pmatrix_numel,int* pmatrix_ndims,int** pmatrix_size,const mxArray* mxmatrix){
 
@@ -39,6 +39,6 @@
 	ndims=mxGetNumberOfDimensions(mxmatrix);
 	ipt  =mxGetDimensions(mxmatrix);
-	size =(int *) xcalloc(ndims,sizeof(int));
-	for (i=0; i<ndims; i++) size[i]=(int)ipt[i];
+	size =xNew<int>(ndims);
+	for (i=0;i<ndims;i++) size[i]=(int)ipt[i];
 
 	/*Ok, first check if we are dealing with a sparse or full matrix: */
@@ -51,5 +51,5 @@
 		nz=(int)((double)nnz/(double)rows);
 
-		matrix=(double*)xcalloc(rows*cols,sizeof(double));
+		matrix=xNewZeroInit<double>(rows*cols);
 
 		/*Now, get ir,jc and pr: */
@@ -74,7 +74,7 @@
 		
 		/*Create serial matrix: */
-		matrix=(double*)xcalloc(numel,sizeof(double));
-
-		dims=(int *) xcalloc(ndims,sizeof(int));
+		matrix=xNewZeroInit<double>(numel);
+
+		dims=xNew<int>(ndims);
 		for(i=0;i<numel;i++){
 			ColumnWiseDimsFromIndex(dims,i,size,ndims);
@@ -82,5 +82,5 @@
 			*(matrix+j)=*(mxmatrix_ptr+i);
 		}
-		xfree((void**)&dims);
+		xDelete<int>(dims);
 		
 	}
@@ -95,5 +95,5 @@
 }
 /*}}}*/
-/*FUNCTION MatlabNArrayToNArray(bool** pmatrix,int* pmatrix_numel,int* pmatrix_ndims,int** pmatrix_size,const mxArray* mxmatrix){{{1*/
+/*FUNCTION MatlabNArrayToNArray(bool** pmatrix,int* pmatrix_numel,int* pmatrix_ndims,int** pmatrix_size,const mxArray* mxmatrix){{{*/
 int MatlabNArrayToNArray(bool** pmatrix,int* pmatrix_numel,int* pmatrix_ndims,int** pmatrix_size,const mxArray* mxmatrix){
 
@@ -119,6 +119,6 @@
 	ndims=mxGetNumberOfDimensions(mxmatrix);
 	ipt  =mxGetDimensions(mxmatrix);
-	size =(int *) xcalloc(ndims,sizeof(int));
-	for (i=0; i<ndims; i++) size[i]=(int)ipt[i];
+	size =xNew<int>(ndims);
+	for (i=0;i<ndims;i++) size[i]=(int)ipt[i];
 
 	/*Ok, first check if we are dealing with a sparse or full matrix: */
@@ -131,5 +131,5 @@
 		nz=(int)((double)nnz/(double)rows);
 
-		matrix=(bool*)xcalloc(rows*cols,sizeof(bool));
+		matrix=xNewZeroInit<bool>(rows*cols);
 
 		/*Now, get ir,jc and pm: */
@@ -154,7 +154,6 @@
 		
 		/*Create serial matrix: */
-		matrix=(bool*)xcalloc(numel,sizeof(bool));
-
-		dims=(int *) xcalloc(ndims,sizeof(int));
+		matrix=xNew<bool>(numel);
+		dims=xNew<int>(ndims);
 		for(i=0;i<numel;i++){
 			ColumnWiseDimsFromIndex(dims,i,size,ndims);
@@ -162,6 +161,5 @@
 			*(matrix+j)=(bool)*(mxmatrix_ptr+i);
 		}
-		xfree((void**)&dims);
-		
+		xDelete<int>(dims);
 	}
 
@@ -175,12 +173,12 @@
 }
 /*}}}*/
-/*FUNCTION MatlabNArrayToNArray(char** pmatrix,int* pmatrix_numel,int* pmatrix_ndims,int** pmatrix_size,const mxArray* mxmatrix){{{1*/
+/*FUNCTION MatlabNArrayToNArray(char** pmatrix,int* pmatrix_numel,int* pmatrix_ndims,int** pmatrix_size,const mxArray* mxmatrix){{{*/
 int MatlabNArrayToNArray(char** pmatrix,int* pmatrix_numel,int* pmatrix_ndims,int** pmatrix_size,const mxArray* mxmatrix){
 
-	int  i,j,rows,cols;
-	int  numel,ndims;
-	int *size,*dims;
-	mxChar* mxmatrix_ptr=NULL;
-	const mwSize* ipt=NULL;
+	int           i,j,rows,cols;
+	int           numel,ndims;
+	int          *size , *dims;
+	mxChar       *mxmatrix_ptr = NULL;
+	const mwSize *ipt          = NULL;
 
 	/*output: */
@@ -188,10 +186,10 @@
 
 	/*matlab indices: */
-	mwIndex*    ir=NULL;
-	mwIndex*    jc=NULL;
-	char*   pm=NULL;
-	int     count;
-	int     nnz;
-	int     nz;
+	mwIndex *ir    = NULL;
+	mwIndex *jc    = NULL;
+	char    *pm    = NULL;
+	int      count;
+	int      nnz;
+	int      nz;
 
 	/*get Matlab matrix information: */
@@ -199,6 +197,6 @@
 	ndims=mxGetNumberOfDimensions(mxmatrix);
 	ipt  =mxGetDimensions(mxmatrix);
-	size =(int *) xcalloc(ndims,sizeof(int));
-	for (i=0; i<ndims; i++) size[i]=(int)ipt[i];
+	size =xNew<int>(ndims);
+	for (i=0;i<ndims;i++) size[i]=(int)ipt[i];
 
 	/*Ok, first check if we are dealing with a sparse or full matrix: */
@@ -211,5 +209,5 @@
 		nz=(int)((double)nnz/(double)rows);
 
-		matrix=(char*)xcalloc(rows*cols,sizeof(double));
+		matrix=xNew<char>(rows*cols);
 
 		/*Now, get ir,jc and pm: */
@@ -234,5 +232,6 @@
 		
 		/*Create serial matrix: */
-		matrix=(char*)xcalloc(numel+1,sizeof(mxChar));
+		matrix=xNew<char>(numel+1);
+		matrix[numel]='\0';
 
 		/*looping code adapted from Matlab example explore.c: */
@@ -259,5 +258,4 @@
 			}
 		}
-
 	}
 
Index: issm/branches/trunk-jpl-damage/src/c/matlab/io/MatlabVectorToDoubleVector.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/matlab/io/MatlabVectorToDoubleVector.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/matlab/io/MatlabVectorToDoubleVector.cpp	(revision 12878)
@@ -46,10 +46,10 @@
 		
 		/*Check that input is actualy a vector*/
-		if (cols!=1) _error_("input vector of size %ix%i should have only one column",rows,cols);
+		if (cols!=1) _error2_("input vector of size " << rows << "x" << cols << " should have only one column");
 
 		nz=(int)((double)nnz/(double)rows);
 
 		if(rows){
-			vector=(double*)xcalloc(rows,sizeof(double));
+			vector=xNewZeroInit<double>(rows);
 
 			/*Now, get ir,jc and pr: */
@@ -77,9 +77,9 @@
 
 		/*Check that input is actualy a vector*/
-		if (cols!=1) _error_("input vector of size %ix%i should have only one column",rows,cols);
+		if (cols!=1) _error2_("input vector of size " << rows << "x" << cols << " should have only one column");
 
 		/*allocate and memcpy*/
 		if(rows){
-			vector=(double*)xmalloc(rows*sizeof(double));
+			vector=xNew<double>(rows);
 			memcpy(vector,mxvector_ptr,rows*sizeof(double));
 		}
Index: issm/branches/trunk-jpl-damage/src/c/matlab/io/MatlabVectorToPetscVec.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/matlab/io/MatlabVectorToPetscVec.cpp	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/c/matlab/io/MatlabVectorToPetscVec.cpp	(revision 12878)
@@ -0,0 +1,109 @@
+/* \file MatlabVectorToPetscVector.cpp
+ * \brief: convert a sparse or dense matlab vector to a serial Petsc vector:
+ */
+
+
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+/*Petsc includes: */
+#include "petscmat.h"
+#include "petscvec.h"
+#include "petscksp.h"
+
+/*Matlab includes: */
+#include "mex.h"
+
+#include "../../shared/shared.h"
+#include "matlabio.h"
+
+PetscVec* MatlabVectorToPetscVec(const mxArray* mxvector){
+
+	int dummy;
+	PetscVec* vector=new PetscVec();
+	
+	MatlabVectorToPetscVec(&vector->vector,&dummy, mxvector);
+
+	return vector;
+}
+
+int MatlabVectorToPetscVec(Vec* pvector,int* pvector_rows,const mxArray* mxvector){
+
+	int rows, cols;
+	double* mxvector_ptr=NULL;
+	int ierr;
+	int i,j;
+
+	/*output: */
+	Vec vector=NULL;
+
+	/*matlab indices: */
+	mwIndex*    ir=NULL;
+	mwIndex*    jc=NULL;
+	double* pr=NULL;
+	int     count;
+	int     nnz;
+	int     nz;
+
+	/*petsc indices: */
+	int* idxm=NULL;
+	
+	/*Ok, first check if we are dealing with a sparse or full vector: */
+	if (mxIsSparse(mxvector)){
+
+		/*Dealing with sparse vector: recover size first: */
+		mxvector_ptr=(double*)mxGetPr(mxvector);
+		rows=mxGetM(mxvector);
+		cols=mxGetN(mxvector);
+		nnz=mxGetNzmax(mxvector);
+		nz=(int)((double)nnz/(double)rows);
+
+		ierr=VecCreateSeq(PETSC_COMM_SELF,rows,&vector);CHKERRQ(ierr);
+
+		/*Now, get ir,jc and pr: */
+		pr=mxGetPr(mxvector);
+		ir=mxGetIr(mxvector);
+		jc=mxGetJc(mxvector);
+
+		/*Now, start inserting data into sparse vector: */
+		count=0;
+		for(i=0;i<cols;i++){
+			for(j=0;j<(jc[i+1]-jc[i]);j++){
+				VecSetValue(vector,ir[count],pr[count],INSERT_VALUES);
+				count++;
+			}
+		}
+
+	}
+	else{
+
+		/*Dealing with dense vector: recover pointer and size: */
+		mxvector_ptr=(double*)mxGetPr(mxvector);
+		rows=mxGetM(mxvector);
+		cols=mxGetN(mxvector);
+
+		/*Create serial vector: */
+		ierr=VecCreateSeq(PETSC_COMM_SELF,rows,&vector);CHKERRQ(ierr);
+
+		/*Insert mxvector_ptr values into petsc vector: */
+		idxm=xNew<int>(rows);
+
+		for(i=0;i<rows;i++)idxm[i]=i;
+
+		ierr=VecSetValues(vector,rows,idxm,mxvector_ptr,INSERT_VALUES);CHKERRQ(ierr);
+
+	}
+
+	/*Assemble vector: */
+	VecAssemblyBegin(vector);
+	VecAssemblyEnd(vector);
+
+	/*Assign output pointer: */
+	*pvector=vector;
+	*pvector_rows=rows;
+
+	return 1;
+}
Index: issm/branches/trunk-jpl-damage/src/c/matlab/io/MatlabVectorToSeqVec.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/matlab/io/MatlabVectorToSeqVec.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/matlab/io/MatlabVectorToSeqVec.cpp	(revision 12878)
@@ -3,5 +3,5 @@
 
 /*Headers:*/
-/*{{{1*/
+/*{{{*/
 #ifdef HAVE_CONFIG_H
 	#include <config.h>
Index: issm/branches/trunk-jpl-damage/src/c/matlab/io/MatlabVectorToVector.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/matlab/io/MatlabVectorToVector.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/matlab/io/MatlabVectorToVector.cpp	(revision 12878)
@@ -3,5 +3,5 @@
 
 /*Headers:*/
-/*{{{1*/
+/*{{{*/
 #ifdef HAVE_CONFIG_H
 	#include <config.h>
@@ -14,5 +14,5 @@
 #include <string.h>
 #include "./matlabio.h"
-#include "../../objects/objects.h"
+#include "../../classes/classes.h"
 #include "../../shared/shared.h"
 #include "../../Container/Container.h"
@@ -31,7 +31,7 @@
 
 	#ifdef _HAVE_PETSC_
-	MatlabVectorToPetscVector(&vector->vector,&dummy,mxvector);
+	vector->pvector=MatlabVectorToPetscVec(mxvector);
 	#else
-	vector->vector=MatlabVectorToSeqVec(mxvector);
+	vector->svector=MatlabVectorToSeqVec(mxvector);
 	#endif
 	
Index: issm/branches/trunk-jpl-damage/src/c/matlab/io/OptionParse.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/matlab/io/OptionParse.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/matlab/io/OptionParse.cpp	(revision 12878)
@@ -8,4 +8,6 @@
 #endif
 
+#include <cstring> 
+#include <mex.h>
 #include "../../shared/shared.h"
 #include "../../io/io.h"
@@ -13,7 +15,5 @@
 #include "./matlabio.h"
 
-#include <mex.h>
-
-/*FUNCTION OptionDoubleParse {{{1*/
+/*FUNCTION OptionDoubleParse {{{*/
 OptionDouble* OptionDoubleParse( char* name, const mxArray* prhs[]){
 
@@ -22,17 +22,16 @@
 	/*check and parse the name  */
 	odouble=new OptionDouble;
-	odouble->name =(char *) xmalloc((strlen(name)+1)*sizeof(char));
+	odouble->name =xNew<char>(strlen(name)+1);
 	memcpy(odouble->name,name,(strlen(name)+1)*sizeof(char));
 
 	/*check and parse the value  */
 	if (!mxIsClass(prhs[0],"double")){
-		_error_("Value of option \"%s\" must be class \"%s\", not class \"%s\".",odouble->name,"double",odouble->name,mxGetClassName(prhs[0]));
+		_error2_("Value of option \"" << odouble->name  << "\" must be class \"double\", not class \"" << mxGetClassName(prhs[0]) <<"\".");
 	}
-
 	FetchData(&odouble->values,&odouble->numel,&odouble->ndims,&odouble->size,prhs[0]);
 
 	return(odouble);
 }/*}}}*/
-/*FUNCTION OptionLogicalParse {{{1*/
+/*FUNCTION OptionLogicalParse {{{*/
 OptionLogical* OptionLogicalParse( char* name, const mxArray* prhs[]){
 
@@ -41,17 +40,16 @@
 	/*check and parse the name  */
 	ological=new OptionLogical;
-	ological->name =(char*)xmalloc((strlen(name)+1)*sizeof(char));
+	ological->name =xNew<char>(strlen(name)+1);
 	memcpy(ological->name,name,(strlen(name)+1)*sizeof(char));
 
 	/*check and parse the value  */
 	if (!mxIsClass(prhs[0],"logical")){
-		_error_("Value of option \"%s\" must be class \"%s\", not class \"%s\".",ological->name,"logical",ological->name,mxGetClassName(prhs[0]));
+		_error2_("Value of option \"" << ological->name  << "\" must be class \"logical\", not class \"" << mxGetClassName(prhs[0]) <<"\".");
 	}
-
 	FetchData(&ological->values,&ological->numel,&ological->ndims,&ological->size,prhs[0]);
 
 	return(ological);
 }/*}}}*/
-/*FUNCTION OptionCharParse {{{1*/
+/*FUNCTION OptionCharParse {{{*/
 OptionChar* OptionCharParse( char* name, const mxArray* prhs[]){
 
@@ -60,17 +58,16 @@
 	/*check and parse the name  */
 	ochar=new OptionChar();
-	ochar->name =(char*)xmalloc((strlen(name)+1)*sizeof(char));
+	ochar->name =xNew<char>(strlen(name)+1);
 	memcpy(ochar->name,name,(strlen(name)+1)*sizeof(char));
 
 	/*check and parse the value  */
 	if (!mxIsClass(prhs[0],"char")){
-		_error_("Value of option \"%s\" must be class \"%s\", not class \"%s\".",ochar->name,"char",ochar->name,mxGetClassName(prhs[0]));
+		_error2_("Value of option \"" << ochar->name  << "\" must be class \"char\", not class \"" << mxGetClassName(prhs[0]) <<"\".");
 	}
-
 	FetchData(&ochar->values,&ochar->numel,&ochar->ndims,&ochar->size,prhs[0]);
 
 	return(ochar);
 }/*}}}*/
-/*FUNCTION OptionStructParse {{{1*/
+/*FUNCTION OptionStructParse {{{*/
 OptionStruct* OptionStructParse( char* name, const mxArray* prhs[]){
 
@@ -85,18 +82,17 @@
 	/*check and parse the name  */
 	ostruct=new OptionStruct;
-	ostruct->name =(char*)xmalloc((strlen(name)+1)*sizeof(char));
+	ostruct->name =xNew<char>(strlen(name)+1);
 	memcpy(ostruct->name,name,(strlen(name)+1)*sizeof(char));
 
 	/*check and parse the value  */
 	if (!mxIsClass(prhs[0],"struct")){
-		_error_("Value of option \"%s\" must be class \"%s\", not class \"%s\".",ostruct->name,"struct",ostruct->name,mxGetClassName(prhs[0]));
+		_error2_("Value of option \"" << ostruct->name  << "\" must be class \"struct\", not class \"" << mxGetClassName(prhs[0]) <<"\".");
 	}
-
 	ostruct->numel=mxGetNumberOfElements(prhs[0]);
 	ostruct->ndims=mxGetNumberOfDimensions(prhs[0]);
 	ipt           =mxGetDimensions(prhs[0]);
-	ostruct->size =(int *) xmalloc(ostruct->ndims*sizeof(int));
+	ostruct->size =xNew<int>(ostruct->ndims);
 	for (i=0; i<ostruct->ndims; i++) ostruct->size[i]=(int)ipt[i];
-	if (ostruct->numel) ostruct->values=(Options**) xmalloc(ostruct->numel*sizeof(Options *));
+	if (ostruct->numel) ostruct->values=xNew<Options*>(ostruct->numel);
 
 	/*loop through and process each element of the struct array  */
@@ -117,5 +113,5 @@
 	return(ostruct);
 }/*}}}*/
-/*FUNCTION OptionCellParse {{{1*/
+/*FUNCTION OptionCellParse {{{*/
 OptionCell* OptionCellParse( char* name, const mxArray* prhs[]){
 
@@ -132,10 +128,10 @@
 	/*check and parse the name  */
 	ocell=new OptionCell;
-	ocell->name =(char *) xmalloc((strlen(name)+1)*sizeof(char));
+	ocell->name =xNew<char>(strlen(name)+1);
 	memcpy(ocell->name,name,(strlen(name)+1)*sizeof(char));
 
 	/*check and parse the value  */
 	if (!mxIsClass(prhs[0],"cell")){
-		_error_("Value of option \"%s\" must be class \"%s\", not class \"%s\".",ocell->name,"cell",ocell->name,mxGetClassName(prhs[0]));
+		_error2_("Value of option \"" << ocell->name  << "\" must be class \"cell\", not class \"" << mxGetClassName(prhs[0]) <<"\".");
 	}
 
@@ -143,10 +139,10 @@
 	ocell->ndims=mxGetNumberOfDimensions(prhs[0]);
 	ipt         =mxGetDimensions(prhs[0]);
-	ocell->size =(int *) xmalloc(ocell->ndims*sizeof(int));
+	ocell->size =xNew<int>(ocell->ndims);
 	for (i=0; i<ocell->ndims; i++) ocell->size[i]=(int)ipt[i];
 	ocell->values=new Options;
 
 	/*loop through and process each element of the cell array  */
-	dims=(int *) xmalloc(ocell->ndims*sizeof(int));
+	dims=xNew<int>(ocell->ndims);
 	for (cindex=0; cindex<ocell->numel; cindex++) {
 		ColumnWiseDimsFromIndex(dims,(int)cindex,ocell->size,ocell->ndims);
@@ -163,9 +159,9 @@
 		option=NULL;
 	}
-	xfree((void**)&dims);
+	xDelete<int>(dims);
 
 	return(ocell);
 }/*}}}*/
-/*FUNCTION OptionParse{{{1*/
+/*FUNCTION OptionParse{{{*/
 Option* OptionParse(char* name, const mxArray* prhs[]){
 
@@ -180,10 +176,10 @@
 	else if(mxIsClass(prhs[0],"cell"))    option=(Option*)OptionCellParse(name,prhs);
 	else {
-		_printf_(true,"  Converting value of option \"%s\" from unrecognized class \"%s\" to class \"%s\".\n",name,mxGetClassName(prhs[0]),"struct");
+		_pprintLine_("  Converting value of option \"" << name << "\" from unrecognized class \"" << mxGetClassName(prhs[0]) << "\" to class \"" << "struct" << "\".");
 		if (!mexCallMATLAB(1,lhs,1,(mxArray**)prhs,"struct")) {
 			option=(Option*)OptionStructParse(name,(const mxArray**)lhs);
 			mxDestroyArray(lhs[0]);
 		}
-		else _error_("Second argument value of option \"%s\" is of unrecognized class \"%s\".",name,mxGetClassName(prhs[0]));
+		else _error2_("Second argument value of option \""<< name <<"\" is of unrecognized class \""<< mxGetClassName(prhs[0]) <<"\".");
 	}
 
Index: issm/branches/trunk-jpl-damage/src/c/matlab/io/PrintfFunction.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/matlab/io/PrintfFunction.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/matlab/io/PrintfFunction.cpp	(revision 12878)
@@ -27,5 +27,5 @@
 
 		/*allocate buffer for given string size*/
-		buffer=(char*)xmalloc(size*sizeof(char));
+		buffer=xNew<char>(size);
 
 		/* Try to print in the allocated space. */
@@ -47,12 +47,12 @@
 		 size*=2;  /* twice the old size */
 
-		xfree((void**)&buffer);
+		xDelete<char>(buffer);
 	}
 
 	/*Ok, if we are running in parallel, get node 0 to print*/
-	if(my_rank==0)printf(buffer);
+	if(my_rank==0)_printString_(buffer);
 
 	/*Clean up and return*/
-	xfree((void**)&buffer);
+	xDelete<char>(buffer);
 	return 1;
 }
Index: issm/branches/trunk-jpl-damage/src/c/matlab/io/WriteMatlabData.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/matlab/io/WriteMatlabData.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/matlab/io/WriteMatlabData.cpp	(revision 12878)
@@ -17,5 +17,5 @@
 
 /*Primitive data types*/
-/*FUNCTION WriteData(mxArray** pdataref,double* matrix, int M,int N){{{1*/
+/*FUNCTION WriteData(mxArray** pdataref,double* matrix, int M,int N){{{*/
 void WriteData(mxArray** pdataref,double* matrix, int M,int N){
 
@@ -42,5 +42,5 @@
 }
 /*}}}*/
-/*FUNCTION WriteData(mxArray** pdataref,int* matrix, int M,int N){{{1*/
+/*FUNCTION WriteData(mxArray** pdataref,int* matrix, int M,int N){{{*/
 void WriteData(mxArray** pdataref,int* matrix, int M,int N){
 
@@ -67,5 +67,5 @@
 }
 /*}}}*/
-/*FUNCTION WriteData(mxArray** pdataref,double* vector, int M){{{1*/
+/*FUNCTION WriteData(mxArray** pdataref,double* vector, int M){{{*/
 void WriteData(mxArray** pdataref,double* vector, int M){
 	
@@ -90,5 +90,5 @@
 }
 /*}}}*/
-/*FUNCTION WriteData(mxArray** pdataref,double scalar){{{1*/
+/*FUNCTION WriteData(mxArray** pdataref,double scalar){{{*/
 void WriteData(mxArray** pdataref,double scalar){
 
@@ -96,5 +96,5 @@
 }
 /*}}}*/
-/*FUNCTION WriteData(mxArray** pdataref,int integer){{{1*/
+/*FUNCTION WriteData(mxArray** pdataref,int integer){{{*/
 void WriteData(mxArray** pdataref,int integer){
 
@@ -103,5 +103,5 @@
 }
 /*}}}*/
-/*FUNCTION WriteData(mxArray** pdataref,int boolean){{{1*/
+/*FUNCTION WriteData(mxArray** pdataref,int boolean){{{*/
 void WriteData(mxArray** pdataref,bool boolean){
 
@@ -110,5 +110,5 @@
 }
 /*}}}*/
-/*FUNCTION WriteData(mxArray** pdataref,char* string){{{1*/
+/*FUNCTION WriteData(mxArray** pdataref,char* string){{{*/
 void WriteData(mxArray** pdataref,char* string){
 
@@ -118,5 +118,5 @@
 
 /*ISSM objects*/
-/*FUNCTION WriteData(mxArray** pdataref,BamgGeom* bamggeom){{{1*/
+/*FUNCTION WriteData(mxArray** pdataref,BamgGeom* bamggeom){{{*/
 void WriteData(mxArray** pdataref,BamgGeom* bamggeom){
 
@@ -158,5 +158,5 @@
 }
 /*}}}*/
-/*FUNCTION WriteData(mxArray** pdataref,BamgMesh* bamgmesh){{{1*/
+/*FUNCTION WriteData(mxArray** pdataref,BamgMesh* bamgmesh){{{*/
 void WriteData(mxArray** pdataref,BamgMesh* bamgmesh){
 
@@ -216,5 +216,5 @@
 }
 /*}}}*/
-/*FUNCTION WriteData(mxArray** pdataref,Matrix* matrix){{{1*/
+/*FUNCTION WriteData(mxArray** pdataref,Matrix* matrix){{{*/
 void WriteData(mxArray** pdataref,Matrix* matrix){
 		
@@ -227,10 +227,6 @@
 	if(matrix){
 		
-		#ifdef _HAVE_PETSC_
-		PetscMatrixToDoubleMatrix(&matrix_ptr,&rows,&cols,matrix->matrix);
-		#else
-		matrix_ptr=matrix->matrix->ToSerial();
-		matrix->matrix->GetSize(&rows,&cols);
-		#endif
+		matrix_ptr=matrix->ToSerial();
+		matrix->GetSize(&rows,&cols);
 
 		/*Now transpose the matrix and allocate with Matlab's memory manager: */
@@ -249,15 +245,15 @@
 
 		/*Free ressources:*/
-		xfree((void**)&matrix_ptr);
-
-	}
-	else{
-		dataref = mxCreateDoubleMatrix(0,0,mxREAL);
-	}
-
-	*pdataref=dataref;
-}
-/*}}}*/
-/*FUNCTION WriteData(mxArray** pdataref,Vector* vector){{{1*/
+		xDelete<double>(matrix_ptr);
+
+	}
+	else{
+		dataref = mxCreateDoubleMatrix(0,0,mxREAL);
+	}
+
+	*pdataref=dataref;
+}
+/*}}}*/
+/*FUNCTION WriteData(mxArray** pdataref,Vector* vector){{{*/
 void WriteData(mxArray** pdataref,Vector* vector){
 	
@@ -269,10 +265,6 @@
 	if(vector){
 		/*call toolkit routine: */
-		#ifdef _HAVE_PETSC_
-		PetscVectorToDoubleVector(&vector_ptr,&rows,vector->vector);
-		#else
-		vector_ptr=vector->vector->ToMPISerial();
-		vector->vector->GetSize(&rows);
-		#endif
+		vector_ptr=vector->ToMPISerial();
+		vector->GetSize(&rows);
 		
 		/*now create the matlab vector with Matlab's memory manager */
@@ -290,5 +282,5 @@
 
 	/*Clean-up and return*/
-	xfree((void**)&vector_ptr);
+	xDelete<double>(vector_ptr);
 	*pdataref=dataref;
 }
@@ -296,5 +288,5 @@
 
 /*Toolkit*/
-/*FUNCTION SetStructureField{{{1*/
+/*FUNCTION SetStructureField{{{*/
 void SetStructureField(mxArray* dataref,const char* fieldname,int M,int N,double* fieldpointer){
 
Index: issm/branches/trunk-jpl-damage/src/c/matlab/io/matlabio.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/matlab/io/matlabio.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/matlab/io/matlabio.h	(revision 12878)
@@ -12,5 +12,5 @@
 #endif 
 
-#include "../../objects/objects.h"
+#include "../../classes/classes.h"
 #include "../../Container/Container.h"
 #include "../../include/include.h"
@@ -79,6 +79,8 @@
 /*Matlab to Petsc routines: */
 #ifdef _HAVE_PETSC_
-int MatlabMatrixToPetscMatrix(Mat* matrix,int* prows,int* pcols, const mxArray* mxmatrix);
-int MatlabVectorToPetscVector(Vec* pvector,int* pvector_rows,const mxArray* mxvector);
+int MatlabMatrixToPetscMat(Mat* matrix,int* prows,int* pcols, const mxArray* mxmatrix);
+PetscMat* MatlabMatrixToPetscMat(const mxArray* mxmatrix);
+int MatlabVectorToPetscVec(Vec* pvector,int* pvector_rows,const mxArray* mxvector);
+PetscVec* MatlabVectorToPetscVec(const mxArray* mxvector);
 #endif
 
Index: issm/branches/trunk-jpl-damage/src/c/modules/AddExternalResultx/AddExternalResultx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/AddExternalResultx/AddExternalResultx.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/AddExternalResultx/AddExternalResultx.cpp	(revision 12878)
@@ -7,5 +7,5 @@
 #include "../../Container/Container.h"
 #include "../../io/io.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 		
 void AddExternalResultx( DataSet* results, int enumtype, double value){
Index: issm/branches/trunk-jpl-damage/src/c/modules/AverageFilterx/AverageFilterx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/AverageFilterx/AverageFilterx.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/AverageFilterx/AverageFilterx.cpp	(revision 12878)
@@ -18,7 +18,7 @@
 
 	/*output: */
-	double*         imageout=NULL;
+	double* imageout=NULL;
 
-	imageout=(double*)xmalloc(samps*lines*sizeof(double));
+	imageout=xNew<double>(samps*lines);
 
   	for ( i = 0; i < lines; i++ ){
Index: issm/branches/trunk-jpl-damage/src/c/modules/AverageOntoPartitionx/AverageOntoPartitionx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/AverageOntoPartitionx/AverageOntoPartitionx.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/AverageOntoPartitionx/AverageOntoPartitionx.cpp	(revision 12878)
@@ -65,5 +65,5 @@
 
 	/*Free ressources:*/
-	xfree((void**)&qmu_part);
+	xDelete<double>(qmu_part);
 	xdelete(&partition_contributions);
 	xdelete(&partition_areas);
Index: issm/branches/trunk-jpl-damage/src/c/modules/AverageOntoPartitionx/AverageOntoPartitionx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/AverageOntoPartitionx/AverageOntoPartitionx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/AverageOntoPartitionx/AverageOntoPartitionx.h	(revision 12878)
@@ -6,5 +6,5 @@
 #define _AVERAGEONTOPARTITIONXX_H
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../Container/Container.h"
 
Index: issm/branches/trunk-jpl-damage/src/c/modules/BamgConvertMeshx/BamgConvertMeshx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/BamgConvertMeshx/BamgConvertMeshx.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/BamgConvertMeshx/BamgConvertMeshx.cpp	(revision 12878)
@@ -7,35 +7,24 @@
 #include "../../include/include.h"
 #include "../../toolkits/toolkits.h"
-#include "../../objects/objects.h"
+#include "../../classes/bamg/bamgobjects.h"
 
 using namespace bamg;
 using namespace std;
 
-int BamgConvertMeshx(BamgMesh* bamgmesh,BamgGeom* bamggeom,double* index,double* x,double* y,int nods,int nels){
-
-	/*Intermediary*/
-	int i,j,k;
-	int verbose=0;
-	int noerr=1;
+int BamgConvertMeshx(BamgMesh* bamgmesh,BamgGeom* bamggeom,int* index,double* x,double* y,int nods,int nels){
 
 	/*Options*/
-	BamgOpts* bamgopts=NULL;
-	bamgopts=new BamgOpts();
+	BamgOpts* bamgopts=new BamgOpts();
 
-	// read mesh
-	if(verbose) printf("Reading mesh\n");
+	/*read mesh*/
 	Mesh Th(index,x,y,nods,nels); 
 
-	//write mesh and geometry
-	if (verbose) printf("Write Geometry\n");
+	/*write mesh and geometry*/
 	Th.Gh.WriteGeometry(bamggeom,bamgopts);
-	if (verbose) printf("Write Mesh\n");
 	Th.WriteMesh(bamgmesh,bamgopts);
 
-	//clean up
+	/*clean up and return*/
 	delete bamgopts;
-
-	/*No error return*/
-	return noerr;
+	return 1;
 
 }
Index: issm/branches/trunk-jpl-damage/src/c/modules/BamgConvertMeshx/BamgConvertMeshx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/BamgConvertMeshx/BamgConvertMeshx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/BamgConvertMeshx/BamgConvertMeshx.h	(revision 12878)
@@ -6,8 +6,8 @@
 #define _BAMGCONVERTMESHX_H
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
-int BamgConvertMeshx(BamgMesh* bamgmesh,BamgGeom* bamggeom,double* index,double* x,double* y,int nods,int nels);
+int BamgConvertMeshx(BamgMesh* bamgmesh,BamgGeom* bamggeom,int* index,double* x,double* y,int nods,int nels);
 
 #endif
Index: issm/branches/trunk-jpl-damage/src/c/modules/BamgTriangulatex/BamgTriangulatex.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/BamgTriangulatex/BamgTriangulatex.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/BamgTriangulatex/BamgTriangulatex.cpp	(revision 12878)
@@ -7,5 +7,5 @@
 #include "../../include/include.h"
 #include "../../toolkits/toolkits.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 using namespace bamg;
Index: issm/branches/trunk-jpl-damage/src/c/modules/BamgTriangulatex/BamgTriangulatex.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/BamgTriangulatex/BamgTriangulatex.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/BamgTriangulatex/BamgTriangulatex.h	(revision 12878)
@@ -6,5 +6,5 @@
 #define _BAMGTRIANGULATEX_H
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
